Package org.mozilla.javascript.ast

## Class KeywordLiteral

- java.lang.Object
- - org.mozilla.javascript.Node
  - - org.mozilla.javascript.ast.AstNode
    - - org.mozilla.javascript.ast.KeywordLiteral

- All Implemented Interfaces:
    `java.lang.Comparable<AstNode>`, `java.lang.Iterable<Node>`

      public class KeywordLiteral
      extends AstNode

  AST node for keyword literals: currently, `this`, `null`, `true`, `false`, and `debugger`. Node type is one of `Token.THIS`, `Token.NULL`, `Token.TRUE`, `Token.FALSE`, or `Token.DEBUGGER`.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode

      `AstNode.DebugPrintVisitor, AstNode.PositionComparator`

    - ### Nested classes/interfaces inherited from class org.mozilla.javascript.Node

      `Node.NodeIterator`

  - ### Field Summary

    - ### Fields inherited from class org.mozilla.javascript.ast.AstNode

      `inlineComment, length, parent, position`

    - ### Fields inherited from class org.mozilla.javascript.Node

      `ARROW_FUNCTION_PROP, ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SHORTHAND_PROPERTY_NAME, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, TEMPLATE_LITERAL_PROP, TRAILING_COMMA, type, VARIABLE_PROP`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `KeywordLiteral()` |
    `KeywordLiteral​(int pos)` |
    `KeywordLiteral​(int pos, int len)` |
    `KeywordLiteral​(int pos, int len, int nodeType)` | Constructs a new KeywordLiteral

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `isBooleanLiteral()` | Returns true if the token type is `Token.TRUE` or `Token.FALSE`.
    `KeywordLiteral` | `setType​(int nodeType)` | Sets node token type
    `java.lang.String` | `toSource​(int depth)` | Emits source code for this node.
    `void` | `visit​(NodeVisitor v)` | Visits this node.

    - ### Methods inherited from class org.mozilla.javascript.ast.AstNode

      `addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getInlineComment, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setInlineComment, setLength, setParent, setPosition, setRelative, shortName, toSource`

    - ### Methods inherited from class org.mozilla.javascript.Node

      `addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getBigInt, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getJsDocNode, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, resetTargets, setBigInt, setDouble, setJsDocNode, setLineno, setScope, setString, toString, toStringTree`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

- - ### Constructor Detail

    - #### KeywordLiteral

          public KeywordLiteral()

    - #### KeywordLiteral

          public KeywordLiteral​(int pos)

    - #### KeywordLiteral

          public KeywordLiteral​(int pos,
                                int len)

    - #### KeywordLiteral

          public KeywordLiteral​(int pos,
                                int len,
                                int nodeType)

      Constructs a new KeywordLiteral
      Parameters:
        `nodeType` - the token type

  - ### Method Detail

    - #### setType

          public KeywordLiteral setType​(int nodeType)

      Sets node token type
      Overrides:
        `setType` in class `Node`
      Throws:
        `java.lang.IllegalArgumentException` - if `nodeType` is unsupported

    - #### isBooleanLiteral

          public boolean isBooleanLiteral()

      Returns true if the token type is `Token.TRUE` or `Token.FALSE`.

    - #### toSource

          public java.lang.String toSource​(int depth)

      Description copied from class: `AstNode`
      Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

      Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

      Specified by:
        `toSource` in class `AstNode`
      Parameters:
        `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

    - #### visit

          public void visit​(NodeVisitor v)

      Visits this node. There are no children to visit.
      Specified by:
        `visit` in class `AstNode`
      Parameters:
        `v` - the object to call with this node and its children